var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var validate_exports = {};
__export(validate_exports, {
  default: () => validate_default,
  validateStream: () => validateStream
});
module.exports = __toCommonJS(validate_exports);
var import_core = require("@datastream/core");
var import__ = __toESM(require("ajv/dist/2020.js"), 1);
var import_ajv_formats = __toESM(require("ajv-formats"), 1);
var import_ajv_formats_draft2019 = __toESM(require("ajv-formats-draft2019"), 1);
var import_fast_uri = __toESM(require("fast-uri"), 1);
const Ajv = import__.default.default;
const ajvDefaults = {
  strict: true,
  coerceTypes: "array",
  allErrors: true,
  useDefaults: "empty",
  uriResolver: import_fast_uri.default
};
const jsonSchemaValidateDefaults = {
  idxStart: 0,
  key: "ajvErrors",
  language: "en",
  availableLanguages: void 0
};
const validateStream = (validateOptions, streamOptions) => {
  let {
    schema,
    idxStart,
    resultKey,
    ...ajvOptions
  } = {
    ...jsonSchemaValidateDefaults,
    ...validateOptions
  };
  if (typeof schema !== "function") {
    const ajv = new Ajv({ ...ajvDefaults, ...ajvOptions });
    (0, import_ajv_formats.default)(ajv);
    (0, import_ajv_formats_draft2019.default)(ajv);
    schema = ajv.compile(schema);
  }
  const value = {};
  let idx = idxStart - 1;
  const transform = (chunk) => {
    idx += 1;
    const chunkValid = schema(chunk);
    if (!chunkValid) {
      for (const error of schema.errors) {
        const { id, keys, message } = processError(error);
        if (!value[id]) {
          value[id] = { id, keys, message, idx: [] };
        }
        value[id].idx.push(idx);
      }
    }
    return chunk;
  };
  const stream = (0, import_core.createTransformStream)(transform, streamOptions);
  stream.result = () => ({ key: resultKey ?? "validate", value });
  return stream;
};
const processError = (error) => {
  const message = error.message || "";
  let id = error.schemaPath;
  let keys = [];
  if (error.keyword === "errorMessage") {
    error.params.errors.forEach((error2) => {
      const value = makeKeys(error2);
      if (value)
        keys.push(value);
    });
    keys = [...new Set(keys.sort())];
  } else {
    keys.push(makeKeys(error));
  }
  if (!error.instancePath && keys.length) {
    id += `/${keys.join("|")}`;
  }
  return { id, keys, message };
};
const makeKeys = (error) => {
  return error.params.missingProperty || error.params.additionalProperty || error.instancePath.replace("/", "");
};
var validate_default = validateStream;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  validateStream
});
